#include  <stdio.h>
#include  <windows.h>

#include  <mysql/mysql.h>
#include  <mysql/mysqld_error.h>
#include  <mysql/errmsg.h>

/************************************************************************************/

int main(int argc, char *argv[])
{
 printf("Open library for dynamic binding...");
 HINSTANCE hInst = LoadLibrary(TEXT("mysqld.dll"));
 if(hInst != NULL)
  {
   printf(" ok\n");

   MYSQL *(CALLBACK *PRC_MYSQL_INIT)         (MYSQL *)                                                                                                        = (MYSQL * (*)(MYSQL *))                                                                                                        GetProcAddress(hInst, TEXT("mysql_init"));
   int    (CALLBACK *PRC_MYSQL_SERVER_INIT)  (int, char **, char **)                                                                                          = (int     (*)(int, char **, char **))                                                                                          GetProcAddress(hInst, TEXT("mysql_server_init"));
   void   (CALLBACK *PRC_MYSQL_SERVER_END)   (void)                                                                                                           = (void    (*)(void))                                                                                                           GetProcAddress(hInst, TEXT("mysql_server_end"));
   int    (CALLBACK *PRC_MYSQL_QUERY)        (MYSQL *, const char *)                                                                                          = (int     (*)(MYSQL *, const char *))                                                                                          GetProcAddress(hInst, TEXT("mysql_query"));
   void   (CALLBACK *PRC_MYSQL_CLOSE)        (MYSQL *)                                                                                                        = (void    (*)(MYSQL *))                                                                                                        GetProcAddress(hInst, TEXT("mysql_close"));
   MYSQL *(CALLBACK *PRC_MYSQL_REAL_CONNECT) (MYSQL *, const char *, const char *, const char *, const char *, unsigned int port, const char *, unsigned int) = (MYSQL * (*)(MYSQL *, const char *, const char *, const char *, const char *, unsigned int port, const char *, unsigned int)) GetProcAddress(hInst, TEXT("mysql_real_connect"));

   char  *server_args[] = { "Not Used", "--language=.", "--log-error=.\\mysqld.log", "--datadir=." };

   printf("Init server...");
   if(PRC_MYSQL_SERVER_INIT(sizeof(server_args)/sizeof(char *), server_args, NULL) == 0)
    {
     printf(" ok\n");
     printf("Init mysql...");
     MYSQL *conn = PRC_MYSQL_INIT((MYSQL *) NULL);
     if(conn != NULL)
      {
       printf(" ok\n");
       printf("Connect to server...");
       if(PRC_MYSQL_REAL_CONNECT(conn, NULL, NULL, NULL, NULL, 0, NULL, 0))
        {
         printf(" ok\n");
         printf("Create database testdb...");
         if(PRC_MYSQL_QUERY(conn, "CREATE DATABASE testdb") == 0)
          {
           printf(" ok\n");
          }
         else
          {
           printf(" failed!\n");
          }
        }
       PRC_MYSQL_CLOSE((MYSQL *) conn);
      }
     else
      {
       printf(" failed!\n");
      }

     PRC_MYSQL_SERVER_END();
    }
   else
    {
     printf(" failed!\n");
    }

   FreeLibrary(hInst);
  }
 else
  {
   printf(" failed!\n");
  }

 return 0;
}

/************************************************************************************/
